# Create netstamps

Products
            Plans
          
        
        
          
            
              
              Formerly ShipEngine
            
            
              Free
              Advanced
              Enterprise
            
          
          
            
              
            
            
              Free
              Starter
              Standard
              Premium
            
          
        
      
      
        
          Learn about products and plans
          
        
      
    

Create one or more NetStamps. Each shipment in the request produces an individual stamp
with optional row/column positioning via advanced_options.netstamps_options.

Endpoint: POST /v2/mailing/netstamps
Version: 2.0.0
Security: api_keys

## Request fields (application/json):

  - `shipments` (array, required)
    The shipments to create NetStamps labels for. All shipments must use the same carrier_id.

Each shipment must include advanced_options.netstamps_options with row and column to control stamp placement. Row/column combinations must be unique across shipments.

  - `shipments.carrier_id` (string,null)
    The carrier account that is billed for the shipping charges
    Example: "se-28529731"

  - `shipments.service_code` (string,null)
    The [carrier service] used to ship the package, such as fedex_ground, usps_first_class_mail, flat_rate_envelope, etc.
    Example: "usps_first_class_mail"

  - `shipments.requested_shipment_service` (string,null)
    The requested shipment service
    Example: "usps_priority_mail"

  - `shipments.external_order_id` (string,null)
    ID that the Order Source assigned
    Example: "1232434"

  - `shipments.hold_until_date` (string,null)
    Date to hold the shipment until
    Example: "2025-01-15T00:00:00.000Z"

  - `shipments.ship_by_date` (string,null)
    Date by which the shipment should be shipped
    Example: "2025-01-15T00:00:00.000Z"

  - `shipments.deliver_by_date` (string,null)
    Date by which the shipment should be delivered
    Example: "2025-01-20T00:00:00.000Z"

  - `shipments.retail_rate` (object,null)
    The retail rate for the shipment

  - `shipments.retail_rate.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.retail_rate.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.store_id` (string)
    The store ID associated with the shipment
    Example: "se-28529731"

  - `shipments.items` (array)
    Describe the packages included in this shipment as related to potential metadata that was imported from
external order sources

  - `shipments.items.name` (string)
    item name
    Example: "box"

  - `shipments.items.sales_order_id` (string,null)
    sales order id
    Example: "12345"

  - `shipments.items.sales_order_item_id` (string,null)
    sales order item id
    Example: "1234556"

  - `shipments.items.quantity` (integer)
    The quantity of this item included in the shipment
    Example: 1

  - `shipments.items.sku` (string,null)
    Item Stock Keeping Unit
    Example: "sku-1234"

  - `shipments.items.bundle_sku` (string,null)
    Bundle SKU for the item
    Example: "bundle-123"

  - `shipments.items.external_order_id` (string,null)
    external order id
    Example: "123445"

  - `shipments.items.external_order_item_id` (string,null)
    external order item id
    Example: "12"

  - `shipments.items.asin` (string,null)
    Amazon Standard Identification Number
    Example: "B00005N5PF"

  - `shipments.items.order_source_code` (string)
    The order sources that are supported by ShipStation
    Enum: "amazon_ca", "amazon_us", "brightpearl", "channel_advisor", "cratejoy", "ebay", "etsy", "jane", "groupon_goods", "magento", "paypal", "seller_active", "shopify", "stitch_labs", "squarespace", "three_dcart", "tophatter", "walmart", "woo_commerce", "volusion"

  - `shipments.items.item_id` (string,null)
    Unique identifier for the item
    Example: "1402291169813"

  - `shipments.items.allocation_status` (string,null)
    Allocation status of the item
    Example: "allocated"

  - `shipments.items.image_url` (string,null)
    URL to the item image
    Example: "https://example.com/image.jpg"

  - `shipments.items.weight` (object)
    Weight of the individual item

  - `shipments.items.weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `shipments.items.weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `shipments.items.unit_price` (number,null)
    Unit price of the item
    Example: 88

  - `shipments.items.tax_amount` (number,null)
    Tax amount for the item
    Example: 5.5

  - `shipments.items.shipping_amount` (number,null)
    Shipping amount for the item
    Example: 10

  - `shipments.items.inventory_location` (string,null)
    Inventory location of the item
    Example: "warehouse-a"

  - `shipments.items.options` (array)
    Item options/variants

  - `shipments.items.options.name` (string)
    Option name
    Example: "Color"

  - `shipments.items.options.value` (string)
    Option value
    Example: "Red"

  - `shipments.items.product_id` (string,null)
    Product ID
    Example: "10408926"

  - `shipments.items.fullfilment_sku` (string,null)
    Fulfillment SKU
    Example: "fulfill-123"

  - `shipments.items.upc` (string,null)
    Universal Product Code
    Example: "123456789012"

  - `shipments.notes_from_buyer` (string,null)
    Notes from the buyer
    Example: "Please handle with care"

  - `shipments.notes_to_buyer` (string,null)
    Notes to the buyer
    Example: "Thank you for your order!"

  - `shipments.notes_for_gift` (string,null)
    Gift notes
    Example: "Happy Birthday!"

  - `shipments.internal_notes` (string,null)
    Internal notes from the seller
    Example: "Check packaging before shipping"

  - `shipments.is_gift` (boolean)
    Indicates if the shipment is a gift
    Example: true

  - `shipments.assigned_user` (string,null)
    User assigned to the shipment
    Example: "user@example.com"

  - `shipments.amount_paid` (object)
    Total amount paid for the order

  - `shipments.amount_paid.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.amount_paid.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.shipping_paid` (object)
    Amount paid for shipping

  - `shipments.shipping_paid.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.shipping_paid.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.tax_paid` (object)
    Amount paid for taxes

  - `shipments.tax_paid.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.tax_paid.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.zone` (integer,null)
    Shipping zone
    Example: 1

  - `shipments.display_scheme` (string,null)
    Display scheme for the shipment
    Example: "label"

  - `shipments.tax_identifiers` (array,null)

  - `shipments.tax_identifiers.taxable_entity_type` (string, required)
    The taxable entity type for this tax item. Valid values include the following

|Value       |Description
|:---------  |:-----------------------------------------------------
|shipper   | The shipper is responsible for this tax.
|recipient | The recipient of the shipment is responsible for this tax.
|ior       | The importer of records is responsible for tax.
    Enum: "shipper", "recipient", "ior"

  - `shipments.tax_identifiers.identifier_type` (string, required)
    Tax identifier type for customs declaration

|Pickup Type    | Description
|---------------|-----------------------------------------
|vat          | The tax identifier is a Value Added Tax.
|eori         | The tax identifier is an Economic Operators Registration and Identification Number (EORI).
|ssn          | The tax identifier is a Social Security Number.
|ein          | The tax identifier is an Employer Identification Number (EIN).
|tin          | The tax identifier is a Tax Identification Number (TIN).
|ioss         | The tax identifier is an Import One-Stop Shop (IOSS).
|pan          | The tax identifier is a Permanent Account Number (PAN).
|voec         | The tax identifier is a Norwegian VAT On E-Commerce(VOEC).
|pccc         | The tax identifier is a Personal Customs Clearance Code (PCCC).
|oss          | The tax identifier is an One-Stop Shop (OSS).
|passport     | The tax identifier is a Passport Number.
|abn          | The tax identifier is an Australian Business Number.
|ukims        | The tax identifier is an UK Internal Market Scheme number.
    Enum: "vat", "eori", "ssn", "ein", "tin", "ioss", "pan", "voec", "pccc", "oss", "passport", "abn", "ukims"

  - `shipments.tax_identifiers.issuing_authority` (string, required)
    The authority that issued this tax. This must be a valid 2 character ISO 3166 Alpha 2 country code.
    Example: "US"

  - `shipments.tax_identifiers.value` (string, required)
    The value of the identifier
    Example: "value"

  - `shipments.external_shipment_id` (string,null)
    A unique user-defined key to identify a shipment.  This can be used to retrieve the shipment.

> Warning: The external_shipment_id is limited to 50 characters. Any additional characters will be truncated.
    Example: "1234556"

  - `shipments.shipment_number` (string,null)
    A non-unique user-defined number used to identify a shipment.  If undefined, this will match the external_shipment_id of the shipment.

> Warning: The shipment_number is limited to 50 characters. Any additional characters will be truncated.
    Example: "10001"

  - `shipments.ship_date` (string,null)
    The date that the shipment was (or will be) shipped.  ShipStation will take the day of week into consideration. For example, if the carrier does not operate on Sundays, then a package that would have shipped on Sunday will ship on Monday instead.
    Example: "2018-09-23T00:00:00Z"

  - `shipments.ship_to` (object, required)
    The recipient's mailing address

  - `shipments.ship_to.name` (string, required)
    The name of a contact person at this address.  This field may be set instead of - or in addition to - the company_name field.
    Example: "John Doe"

  - `shipments.ship_to.phone` (string, required)
    The phone number of a contact person at this address.  The format of this phone number varies depending on the country.
    Example: "+1 204-253-9411 ext. 123"

  - `shipments.ship_to.email` (string,null)
    Email for the address owner.
    Example: "example@example.com"

  - `shipments.ship_to.company_name` (string,null)
    If this is a business address, then the company name should be specified here.
    Example: "The Home Depot"

  - `shipments.ship_to.address_line1` (string, required)
    The first line of the street address.  For some addresses, this may be the only line.  Other addresses may require 2 or 3 lines.
    Example: "1999 Bishop Grandin Blvd."

  - `shipments.ship_to.address_line2` (string,null)
    The second line of the street address.  For some addresses, this line may not be needed.
    Example: "Unit 408"

  - `shipments.ship_to.address_line3` (string,null)
    The third line of the street address.  For some addresses, this line may not be needed.
    Example: "Building #7"

  - `shipments.ship_to.city_locality` (string, required)
    The name of the city or locality
    Example: "Winnipeg"

  - `shipments.ship_to.state_province` (string, required)
    The state or province.  For some countries (including the U.S.) only abbreviations are allowed.  Other countries allow the full name or abbreviation.
    Example: "Manitoba"

  - `shipments.ship_to.postal_code` (string, required)
    postal code
    Example: "78756-3717"

  - `shipments.ship_to.country_code` (string, required)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1)
    Example: "CA"

  - `shipments.ship_to.address_residential_indicator` (string, required)
    Indicates whether this is a residential address.
    Enum: "unknown", "yes", "no"

  - `shipments.ship_to.instructions` (string,null)
    Additional text about how to handle the shipment at this address.
    Example: "any instruction"

  - `shipments.ship_to.geolocation` (array)

  - `shipments.ship_to.geolocation.type` (string)
    Enum of available type of geolocation items:
  - 'what3words' functionality allows to specify a location by providing 3 words that have been assigned to the specific location. See [link](https://what3words.com/business) for more details.
    Enum: "what3words"

  - `shipments.ship_to.geolocation.value` (string)
    value of the geolocation item
    Example: "cats.with.thumbs"

  - `shipments.ship_from` (object, required)
    The shipment's origin address. If you frequently ship from the same location, consider [creating a warehouse].  Then you can simply specify the warehouse_id rather than the complete address each time.

  - `shipments.ship_from.name` (string, required)
    The name of a contact person at this address.  This field may be set instead of - or in addition to - the company_name field.
    Example: "John Doe"

  - `shipments.ship_from.phone` (string, required)
    The phone number of a contact person at this address.  The format of this phone number varies depending on the country.
    Example: "+1 204-253-9411 ext. 123"

  - `shipments.ship_from.email` (string,null)
    Email for the address owner.
    Example: "example@example.com"

  - `shipments.ship_from.company_name` (string,null)
    If this is a business address, then the company name should be specified here.
    Example: "The Home Depot"

  - `shipments.ship_from.address_line1` (string, required)
    The first line of the street address.  For some addresses, this may be the only line.  Other addresses may require 2 or 3 lines.
    Example: "1999 Bishop Grandin Blvd."

  - `shipments.ship_from.address_line2` (string,null)
    The second line of the street address.  For some addresses, this line may not be needed.
    Example: "Unit 408"

  - `shipments.ship_from.address_line3` (string,null)
    The third line of the street address.  For some addresses, this line may not be needed.
    Example: "Building #7"

  - `shipments.ship_from.city_locality` (string, required)
    The name of the city or locality
    Example: "Winnipeg"

  - `shipments.ship_from.state_province` (string, required)
    The state or province.  For some countries (including the U.S.) only abbreviations are allowed.  Other countries allow the full name or abbreviation.
    Example: "Manitoba"

  - `shipments.ship_from.postal_code` (string, required)
    postal code
    Example: "78756-3717"

  - `shipments.ship_from.country_code` (string, required)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1)
    Example: "CA"

  - `shipments.ship_from.address_residential_indicator` (string, required)
    Indicates whether this is a residential address.
    Enum: "unknown", "yes", "no"

  - `shipments.ship_from.instructions` (string,null)
    Additional text about how to handle the shipment at this address.
    Example: "any instructions"

  - `shipments.ship_from.geolocation` (array)

  - `shipments.ship_from.geolocation.type` (string)
    Enum of available type of geolocation items:
  - 'what3words' functionality allows to specify a location by providing 3 words that have been assigned to the specific location. See [link](https://what3words.com/business) for more details.
    Enum: "what3words"

  - `shipments.ship_from.geolocation.value` (string)
    value of the geolocation item
    Example: "cats.with.thumbs"

  - `shipments.warehouse_id` (string,null)
    The [warehouse] that the shipment is being shipped from.  Either warehouse_id or ship_from must be specified.
    Example: "se-28529731"

  - `shipments.return_to` (object, required)
    The return address for this shipment.  Defaults to the ship_from address.  Can be sent with a warehouse_id, in which case the return address can be overridden.  This allows you to have a different address printed on the label while maintaining the origin address.

  - `shipments.return_to.name` (string, required)
    The name of a contact person at this address.  This field may be set instead of - or in addition to - the company_name field.
    Example: "John Doe"

  - `shipments.return_to.phone` (string, required)
    The phone number of a contact person at this address.  The format of this phone number varies depending on the country.
    Example: "+1 204-253-9411 ext. 123"

  - `shipments.return_to.email` (string,null)
    Email for the address owner.
    Example: "example@example.com"

  - `shipments.return_to.company_name` (string,null)
    If this is a business address, then the company name should be specified here.
    Example: "The Home Depot"

  - `shipments.return_to.address_line1` (string, required)
    The first line of the street address.  For some addresses, this may be the only line.  Other addresses may require 2 or 3 lines.
    Example: "1999 Bishop Grandin Blvd."

  - `shipments.return_to.address_line2` (string,null)
    The second line of the street address.  For some addresses, this line may not be needed.
    Example: "Unit 408"

  - `shipments.return_to.address_line3` (string,null)
    The third line of the street address.  For some addresses, this line may not be needed.
    Example: "Building #7"

  - `shipments.return_to.city_locality` (string, required)
    The name of the city or locality
    Example: "Winnipeg"

  - `shipments.return_to.state_province` (string, required)
    The state or province.  For some countries (including the U.S.) only abbreviations are allowed.  Other countries allow the full name or abbreviation.
    Example: "Manitoba"

  - `shipments.return_to.postal_code` (string, required)
    postal code
    Example: "78756-3717"

  - `shipments.return_to.country_code` (string, required)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1)
    Example: "CA"

  - `shipments.return_to.address_residential_indicator` (string, required)
    Indicates whether this is a residential address.
    Enum: "unknown", "yes", "no"

  - `shipments.return_to.instructions` (string,null)
    Additional text about how to handle the shipment at this address.
    Example: "any instructions"

  - `shipments.return_to.geolocation` (array)

  - `shipments.return_to.geolocation.type` (string)
    Enum of available type of geolocation items:
  - 'what3words' functionality allows to specify a location by providing 3 words that have been assigned to the specific location. See [link](https://what3words.com/business) for more details.
    Enum: "what3words"

  - `shipments.return_to.geolocation.value` (string)
    value of the geolocation item
    Example: "cats.with.thumbs"

  - `shipments.is_return` (boolean,null)
    An optional indicator if the shipment is intended to be a return. Defaults to false if not provided.
    Example: true

  - `shipments.confirmation` (string, required)
    The type of delivery confirmation that is required for this shipment
    Enum: "none", "delivery", "signature", "adult_signature", "direct_signature", "delivery_mailed", "verbal_confirmation", "delivery_code", "age_verification_16_plus"

  - `shipments.customs` (object,null)
    Customs information for international shipments.

> Note: International shipments (where ship_from.country_code differs from ship_to.country_code) must include either customs or advanced_options.
> To prepay duties and taxes (DDP / PDT), set customs.terms_of_trade_code to ddp.

> Please note that the guaranteed prepaid duties and taxes option is available only for eligible ShipStation carriers.
    Example: {"terms_of_trade_code":"ddp","contents":"gift","non_delivery":"return_to_sender"}

  - `shipments.customs.contents` (string, required)
    The type of contents in this shipment.  This may impact import duties or customs treatment.
    Enum: "merchandise", "documents", "gift", "returned_goods", "sample", "e_commerce_goods", "commercial_sale_of_goods_b2b", "other"

  - `shipments.customs.contents_explanation` (string)
    Explanation for contents (required if the contents is provided as other)
    Example: "rubber duckies"

  - `shipments.customs.non_delivery` (string, required)
    Indicates what to do if a package is unable to be delivered.
    Enum: "return_to_sender", "treat_as_abandoned"

  - `shipments.customs.terms_of_trade_code` (string)
    Specifies the supported terms of trade code (incoterms)
    Enum: "exw", "fca", "cpt", "cip", "dpu", "dap", "ddp", "fas", "fob", "cfr", "cif", "ddu", "daf", "deq", "des"

  - `shipments.customs.declaration` (string)
    Declaration statement to be placed on the commercial invoice
    Example: "I hereby certify that the information on this invoice is true and correct and that the contents and value of this shipment are as stated above"

  - `shipments.customs.pending_documents` (boolean)
    Set to true to indicate the shipment requires customs documents to be uploaded via Carrier Document Upload. See the [Carrier Document Upload guide](/upload-carrier-documents).
    Example: true

  - `shipments.customs.invoice_additional_details` (object)
    The additional information to put on commercial invoice

  - `shipments.customs.invoice_additional_details.freight_charge` (object)
    Freight Charge for shipment.

  - `shipments.customs.invoice_additional_details.freight_charge.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.customs.invoice_additional_details.freight_charge.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.invoice_additional_details.insurance_charge` (object)
    Insurance Charge for shipment.

  - `shipments.customs.invoice_additional_details.insurance_charge.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.customs.invoice_additional_details.insurance_charge.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.invoice_additional_details.discount` (object)
    Discount for shipment.

  - `shipments.customs.invoice_additional_details.discount.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.customs.invoice_additional_details.discount.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.invoice_additional_details.estimated_import_charges` (object)
    Estimated import charges for commercial invoices for international shipments.

  - `shipments.customs.invoice_additional_details.estimated_import_charges.taxes` (object)
    Estimated import taxes.

  - `shipments.customs.invoice_additional_details.estimated_import_charges.taxes.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.customs.invoice_additional_details.estimated_import_charges.taxes.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.invoice_additional_details.estimated_import_charges.duties` (object)
    Estimated import duties.

  - `shipments.customs.invoice_additional_details.estimated_import_charges.duties.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.customs.invoice_additional_details.estimated_import_charges.duties.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.invoice_additional_details.other_charge` (object)
    Other charge for shipment.

  - `shipments.customs.invoice_additional_details.other_charge.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.customs.invoice_additional_details.other_charge.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.invoice_additional_details.other_charge_description` (string)
    Description for the other charge (if provided).
    Example: "Other charges description"

  - `shipments.customs.importer_of_record` (object)
    importer of records address, anywhere in the world.

  - `shipments.customs.importer_of_record.name` (string, required)
    The name of a contact person at this address. Either name or the company_name field should always be set.
    Example: "John Doe"

  - `shipments.customs.importer_of_record.phone` (string)
    The phone number of a contact person at this address.  The format of this phone number varies depending on the country.
    Example: "+1 204-253-9411 ext. 123"

  - `shipments.customs.importer_of_record.email` (string,null)
    Email for the address owner.
    Example: "example@example.com"

  - `shipments.customs.importer_of_record.company_name` (string,null)
    If this is a business address, then the company name should be specified here. Either name or the company_name field should always be set.
    Example: "The Home Depot"

  - `shipments.customs.importer_of_record.address_line1` (string, required)
    The first line of the street address.  For some addresses, this may be the only line.  Other addresses may require 2 or 3 lines.
    Example: "1999 Bishop Grandin Blvd."

  - `shipments.customs.importer_of_record.address_line2` (string,null)
    The second line of the street address.  For some addresses, this line may not be needed.
    Example: "Unit 408"

  - `shipments.customs.importer_of_record.address_line3` (string,null)
    The third line of the street address.  For some addresses, this line may not be needed.
    Example: "Building #7"

  - `shipments.customs.importer_of_record.city_locality` (string, required)
    The name of the city or locality
    Example: "Winnipeg"

  - `shipments.customs.importer_of_record.state_province` (string)
    The state or province.  For some countries (including the U.S.) only abbreviations are allowed.  Other countries allow the full name or abbreviation.
    Example: "Manitoba"

  - `shipments.customs.importer_of_record.postal_code` (string, required)
    postal code
    Example: "78756-3717"

  - `shipments.customs.importer_of_record.country_code` (string, required)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1)
    Example: "CA"

  - `shipments.customs.customs_items` (array)
    Customs declarations for each item in the shipment. (Please provide this information under products inside packages)

  - `shipments.customs.customs_items.description` (string,null)
    A description of the item
    Example: "This is a description"

  - `shipments.customs.customs_items.quantity` (integer)
    The quantity of this item in the shipment.
    Example: 1

  - `shipments.customs.customs_items.value` (number)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.customs.customs_items.value_currency` (string)
    The currencies that are supported by ShipStation are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html
    Example: "USD"

  - `shipments.customs.customs_items.weight` (object)
    The item weight

  - `shipments.customs.customs_items.weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `shipments.customs.customs_items.weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `shipments.customs.customs_items.harmonized_tariff_code` (string,null)
    The [Harmonized Tariff Code](https://en.wikipedia.org/wiki/Harmonized_System) of this item.
    Example: "3926.10"

  - `shipments.customs.customs_items.country_of_origin` (string,null)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) where this item originated
    Example: "CA"

  - `shipments.customs.customs_items.unit_of_measure` (string,null)
    Example: "pound"

  - `shipments.customs.customs_items.sku` (string,null)
    The SKU (Stock Keeping Unit) of the customs item
    Example: "sku-1234"

  - `shipments.customs.customs_items.sku_description` (string,null)
    Description of the Custom Item's SKU
    Example: "this is a description"

  - `shipments.advanced_options` (object)
    Advanced shipment options.

> Note: International shipments must include either customs or advanced_options.

  - `shipments.advanced_options.bill_to_account` (string,null)
    This field is used to [bill shipping costs to a third party].  This field must be used in conjunction with the bill_to_country_code, bill_to_party, and bill_to_postal_code fields.
    Example: "123456789"

  - `shipments.advanced_options.bill_to_country_code` (string,null)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) of the third-party that is responsible for shipping costs.
    Example: "CA"

  - `shipments.advanced_options.bill_to_party` (string,null)
    Indicates whether to bill shipping costs to the recipient or to a third-party.  When billing to a third-party, the bill_to_account, bill_to_country_code, and bill_to_postal_code fields must also be set.
    Enum: "recipient", "third_party"

  - `shipments.advanced_options.bill_to_postal_code` (string,null)
    The postal code of the third-party that is responsible for shipping costs.
    Example: "28005"

  - `shipments.advanced_options.contains_alcohol` (boolean)
    Indicates that the shipment contains alcohol.
    Example: true

  - `shipments.advanced_options.delivered_duty_paid` (boolean)
    Indicates that the shipper is paying the international delivery duties for this shipment.  This option is supported by UPS, FedEx, and DHL Express.
    Example: true

  - `shipments.advanced_options.dry_ice` (boolean)
    Indicates if the shipment contain dry ice
    Example: true

  - `shipments.advanced_options.dry_ice_weight` (object,null)
    The weight of the dry ice in the shipment

  - `shipments.advanced_options.dry_ice_weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `shipments.advanced_options.dry_ice_weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `shipments.advanced_options.non_machinable` (boolean)
    Indicates that the package cannot be processed automatically because it is too large or irregularly shaped. This is primarily for USPS shipments.  See [Section 1.2 of the USPS parcel standards](https://pe.usps.com/text/dmm300/101.htm#ep1047495) for details.
    Example: true

  - `shipments.advanced_options.saturday_delivery` (boolean)
    Enables Saturday delivery, if supported by the carrier.
    Example: true

  - `shipments.advanced_options.fedex_freight` (object)
    Provide details for the Fedex freight service

  - `shipments.advanced_options.fedex_freight.shipper_load_and_count` (string)
    Example: "shipper_load_and_count"

  - `shipments.advanced_options.fedex_freight.booking_confirmation` (string)
    Example: "today"

  - `shipments.advanced_options.use_ups_ground_freight_pricing` (boolean,null)
    Whether to use [UPS Ground Freight pricing] If enabled, then a freight_class must also be specified.
    Example: true

  - `shipments.advanced_options.freight_class` (string,null)
    The National Motor Freight Traffic Association [freight class](http://www.nmfta.org/pages/nmfc?AspxAutoDetectCookieSupport=1), such as "77.5", "110", or "250".
    Example: "77.5"

  - `shipments.advanced_options.custom_field1` (string,null)
    An arbitrary field that can be used to store information about the shipment.
    Example: "custom field 1"

  - `shipments.advanced_options.custom_field2` (string,null)
    An arbitrary field that can be used to store information about the shipment.
    Example: "custom field 2"

  - `shipments.advanced_options.custom_field3` (string,null)
    An arbitrary field that can be used to store information about the shipment.
    Example: "custom field 3"

  - `shipments.advanced_options.origin_type` (string,null)
    Indicates if the package will be picked up or dropped off by the carrier
    Enum: "pickup", "drop_off"

  - `shipments.advanced_options.additional_handling` (boolean,null)
    Indicate to the carrier that this shipment requires additional handling.
    Example: true

  - `shipments.advanced_options.shipper_release` (boolean,null)
    Example: true

  - `shipments.advanced_options.collect_on_delivery` (object)
    Defer payment until package is delivered, instead of when it is ordered.

  - `shipments.advanced_options.collect_on_delivery.payment_type` (string)
    Types of payment that are supported
    Enum: "any", "cash", "cash_equivalent", "none"

  - `shipments.advanced_options.collect_on_delivery.payment_amount` (object)

  - `shipments.advanced_options.collect_on_delivery.payment_amount.currency` (string)
    The currencies that are supported by ShipStation are the ones that specified by ISO 4217: https://www.iso.org/iso-4217-currency-codes.html
    Example: "USD"

  - `shipments.advanced_options.collect_on_delivery.payment_amount.amount` (number)
    Example: 12

  - `shipments.advanced_options.third_party_consignee` (boolean)
    Third Party Consignee option is a value-added service that allows the shipper to supply goods without commercial invoices being attached
    Example: true

  - `shipments.advanced_options.dangerous_goods` (boolean)
    Indicates if the Dangerous goods are present in the shipment
    Example: true

  - `shipments.advanced_options.dangerous_goods_contact` (object)
    Contact information for Dangerous goods

  - `shipments.advanced_options.dangerous_goods_contact.name` (string)
    Name of the contact
    Example: "Michael Robinson"

  - `shipments.advanced_options.dangerous_goods_contact.phone` (string)
    Phone number of the contact
    Example: "123456578789"

  - `shipments.advanced_options.movement_indicator` (string,null)
    An indicator that will tell the carrier the type of movement for the shipment.
    Enum: "c2c", "b2c", "c2b", "b2b"

  - `shipments.advanced_options.windsor_framework_details` (object)
    The Windsor framework is a new regulation in the UK that simplifies customs procedures for goods moved from the UK mainland to Northern Ireland.

  - `shipments.advanced_options.windsor_framework_details.not_at_risk` (boolean)
    An indicator that allows a shipper to declare the shipment as not-at-risk.
    Example: true

  - `shipments.advanced_options.windsor_framework_details.movement_indicator` (string)
    An indicator that will tell the carrier and HMRC the type of movement for the shipment.
    Enum: "c2c", "b2c", "c2b", "b2b"

  - `shipments.advanced_options.ancillary_endorsements_option` (string,null)
    Ancillary endorsements option for the shipment
    Example: "forward"

  - `shipments.advanced_options.return_pickup_attempts` (integer,null)
    Number of return pickup attempts
    Example: 3

  - `shipments.advanced_options.own_document_upload` (boolean)
    Indicates if own document upload is enabled

  - `shipments.advanced_options.limited_quantity` (boolean)
    Indicates if the shipment contains limited quantities

  - `shipments.advanced_options.event_notification` (boolean)
    Indicates if event notifications are enabled

  - `shipments.advanced_options.fragile` (boolean)
    Indicates if the shipment contains fragile items

  - `shipments.advanced_options.delivery_as_addressed` (boolean)
    Instructs the carrier to deliver the package only to the exact address provided

  - `shipments.advanced_options.return_after_first_attempt` (boolean)
    Ensures the shipment is immediately flagged for return to the sender if the initial delivery attempt fails

  - `shipments.advanced_options.regulated_content_type` (string,null)
    Indicates the category of goods in the shipment that is subject to special regulatory or compliance requirements
    Enum: "day_old_poultry", "other_live_animal"

  - `shipments.advanced_options.netstamps_options` (object)
    Layout options for printing NetStamps labels on a sheet. Controls the starting position on the label sheet.

  - `shipments.advanced_options.netstamps_options.row` (integer)
    The row on the sheet where label is placed.
    Example: 1

  - `shipments.advanced_options.netstamps_options.column` (integer)
    The column on the sheet where label is placed.
    Example: 1

  - `shipments.insurance_provider` (string, required)
    The insurance provider to use for any insured packages in the shipment.
    Enum: "none", "shipsurance", "parcelguard", "xcover", "carrier", "third_party"

  - `shipments.tags` (array, required)
    Arbitrary tags associated with this shipment.  Tags can be used to categorize shipments, and shipments can be queried by their tags. Note: Tags require object structure with name property, not simple strings.

  - `shipments.tags.name` (string, required)
    The tag name.
    Example: "Fragile"

  - `shipments.order_source_code` (string)
    The order sources that are supported by ShipStation
    Enum: "amazon_ca", "amazon_us", "brightpearl", "channel_advisor", "cratejoy", "ebay", "etsy", "jane", "groupon_goods", "magento", "paypal", "seller_active", "shopify", "stitch_labs", "squarespace", "three_dcart", "tophatter", "walmart", "woo_commerce", "volusion"

  - `shipments.packages` (array, required)
    The packages in the shipment.

> Note: Some carriers only allow one package per shipment.  If you attempt to create a multi-package shipment for a carrier that doesn't allow it, an error will be returned.

  - `shipments.packages.package_id` (string)
    A string that uniquely identifies this [package type]
    Example: "se-28529731"

  - `shipments.packages.package_code` (string)
    The [package type] such as thick_envelope, small_flat_rate_box, large_package, etc.  The code package indicates a custom or unknown package type.
    Example: "small_flat_rate_box"

  - `shipments.packages.package_name` (string)
    The name of the of the [package type]
    Example: "Flat Rate Envelope"

  - `shipments.packages.weight` (object, required)
    The package weight

  - `shipments.packages.weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `shipments.packages.weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `shipments.packages.dimensions` (object)
    The package dimensions

  - `shipments.packages.dimensions.unit` (string, required)
    Dimension unit
    Enum: "inch", "centimeter"

  - `shipments.packages.dimensions.length` (number, required)
    The length of the package, in the specified unit
    Example: 2

  - `shipments.packages.dimensions.width` (number, required)
    The width of the package, in the specified unit
    Example: 2

  - `shipments.packages.dimensions.height` (number, required)
    The height of the package, in the specified unit
    Example: 1

  - `shipments.packages.insured_value` (object)
    The insured value of the package.  Requires the insurance_provider field of the shipment to be set.

  - `shipments.packages.insured_value.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.packages.insured_value.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.packages.label_messages` (object)
    Custom messages to print on the shipping label for the package.  These are typically used to print invoice numbers, product numbers, or other internal reference numbers.  Not all carriers support label messages. The number of lines and the maximum length of each line also varies by carrier.

|Carrier            |Max lines |Max line length
|-------------------|----------|--------------------
|USPS (Stamps.com)  |3         |60
|FedEx              |3         |35 for the first line. 30 for additional lines.
|UPS                |2         |35
|OnTrac             |2         |25

  - `shipments.packages.label_messages.reference1` (string,null, required)
    The first line of the custom label message.  Some carriers may prefix this line with something like "REF", "Reference", "Trx Ref No.", etc.
    Example: "Reference"

  - `shipments.packages.label_messages.reference2` (string,null, required)
    The second line of the custom label message.  Some carriers may prefix this line with something like "INV", "Reference 2", "Trx Ref No.", etc.
    Example: "Reference 2"

  - `shipments.packages.label_messages.reference3` (string,null, required)
    The third line of the custom label message.  Some carriers may prefix this line with something like "PO", "Reference 3", etc.
    Example: "Reference 3"

  - `shipments.packages.external_package_id` (string)
    An external package id.
    Example: "se-1234545"

  - `shipments.packages.content_description` (string,null)
    A short description of the package content. Required for shipments moving to, from, and through Mexico.
    Example: "Hand knitted wool socks"

  - `shipments.packages.products` (array)
    Details about products inside packages (Information provided would be used on custom documentation)

  - `shipments.packages.products.description` (string,null)
    A description of the item
    Example: "a minimum description"

  - `shipments.packages.products.quantity` (integer)
    The quantity of this item in the shipment.
    Example: 1

  - `shipments.packages.products.value` (object)
    The declared value of each item

  - `shipments.packages.products.value.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipments.packages.products.value.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `shipments.packages.products.weight` (object)
    The item weight

  - `shipments.packages.products.weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `shipments.packages.products.weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `shipments.packages.products.harmonized_tariff_code` (string,null)
    The [Harmonized Tariff Code](https://en.wikipedia.org/wiki/Harmonized_System) of this item.
    Example: "3926.10"

  - `shipments.packages.products.country_of_origin` (string,null)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1) where this item originated
    Example: "CA"

  - `shipments.packages.products.unit_of_measure` (string,null)
    Example: "pound"

  - `shipments.packages.products.sku` (string,null)
    The SKU (Stock Keeping Unit) of the item
    Example: "sku-1223344"

  - `shipments.packages.products.sku_description` (string,null)
    Description of the Custom Item's SKU
    Example: "this is a description"

  - `shipments.packages.products.mid_code` (string,null)
    Manufacturers Identification code
    Example: "GBCOM15BRI"

  - `shipments.packages.products.product_url` (string,null)
    link to the item on the seller website
    Example: "https://myproduct.com"

  - `shipments.packages.products.vat_rate` (number,null)
    VAT rate applicable to the item
    Example: 0.2

  - `shipments.packages.products.dangerous_goods` (array)
    Details about dangerous goods inside products

  - `shipments.packages.products.dangerous_goods.id_number` (string,null)
    UN number to identify the dangerous goods.
    Example: "1234r1"

  - `shipments.packages.products.dangerous_goods.shipping_name` (string,null)
    Trade description of the dangerous goods.
    Example: "things with dangerous goods"

  - `shipments.packages.products.dangerous_goods.technical_name` (string,null)
    Recognized Technical or chemical name of dangerous goods.
    Example: "chloric acid"

  - `shipments.packages.products.dangerous_goods.product_class` (string,null)
    Dangerous goods product class based on regulation.
    Example: "1987"

  - `shipments.packages.products.dangerous_goods.product_class_subsidiary` (string,null)
    A secondary of product class for substances presenting more than one particular hazard
    Example: "1987"

  - `shipments.packages.products.dangerous_goods.packaging_group` (string)
    Enum: "i", "ii", "iii"

  - `shipments.packages.products.dangerous_goods.dangerous_amount` (object)
    This model represents the amount of the dangerous goods.

  - `shipments.packages.products.dangerous_goods.quantity` (integer)
    Quantity of dangerous goods.
    Example: 1

  - `shipments.packages.products.dangerous_goods.packaging_instruction` (string,null)
    The specific standardized packaging instructions from the relevant regulatory agency that have been applied to the parcel/container.
    Example: "Packaging materials and containers that are in contact with food products must comply with the provisions established by Regulation "

  - `shipments.packages.products.dangerous_goods.packaging_instruction_section` (string)
    Enum: "section_1", "section_2", "section_1a", "section_1b"

  - `shipments.packages.products.dangerous_goods.packaging_type` (string,null)
    The type of exterior packaging used to contain the dangerous good.
    Example: "X"

  - `shipments.packages.products.dangerous_goods.transport_mean` (string)
    Enum: "ground", "water", "cargo_aircraft_only", "passenger_aircraft"

  - `shipments.packages.products.dangerous_goods.transport_category` (string,null)
    Transport category assign to dangerous goods for the transport purpose.
    Example: "6.1"

  - `shipments.packages.products.dangerous_goods.regulation_authority` (string,null)
    Name of the regulatory authority.
    Example: "AEAT"

  - `shipments.packages.products.dangerous_goods.regulation_level` (string)
    Enum: "lightly_regulated", "fully_regulated", "limited_quantities", "excepted_quantity"

  - `shipments.packages.products.dangerous_goods.radioactive` (boolean,null)
    Indication if the substance is radioactive.

  - `shipments.packages.products.dangerous_goods.reportable_quantity` (boolean,null)
    Indication if the substance needs to be reported to regulatory authority based on the quantity.

  - `shipments.packages.products.dangerous_goods.tunnel_code` (string,null)
    Defines which types of tunnels the shipment is allowed to go through
    Example: "all"

  - `shipments.packages.products.dangerous_goods.additional_description` (string,null)
    Provider additonal description regarding the dangerous goods. This is used as a placed holder to provider additional context and varies by carrier
    Example: "any description"

  - `shipments.packages.products.manufacturer_product_id_type` (string,null)
    The type of identifier used for the manufacturer product ID.
    Enum: "undefined", "gtin", "ean", "isbn", "upc", "mpn", "sku"

  - `shipments.packages.products.manufacturer_product_id` (string,null)
    The manufacturer's product identifier corresponding to the manufacturer_product_id_type.
    Example: "012345678905"

  - `shipments.packages.products.manufacturer_ns_product_id` (string,null)
    A non-standardized product identifier unique to the manufacturer's own system that does not follow an internationally recognized standard (e.g. a SKU).
    Example: "MY-SKU-12345"

  - `shipments.packages.products.cpsc_certificates` (array,null)
    List of CPSC eFiling certificates associated with this product.

  - `shipments.packages.products.cpsc_certificates.certifier_id` (string)
    Unique identifier assigned to the certifier by the CPSC.
    Example: "CERT-12345"

  - `shipments.packages.products.cpsc_certificates.certificate_version_id` (string)
    The version identifier of the CPSC certificate.
    Example: "v1.0"

  - `shipments.comparison_rate_type` (string,null)
    Calculate a rate for this shipment with the requested carrier using a ratecard that differs from the default.  Only supported for UPS and USPS.
    Example: "retail"

  - `label_layout` (string, required)
    The NetStamps layout to use.
    Enum: "netstamps_traditional", "netstamps_standard", "netstamps_alternate", "netstamps_promotional", "netstamps_themed", "netstamps_photo_landscape", "netstamps_photo_portrait", "netstamps_photo_landscape_hs", "netstamps_return_address", "netstamps_roll_type_sd", "netstamps_promo_paper20"

  - `label_format` (string)
    The file format for the label.
    Enum: "pdf", "png"

  - `display_scheme` (string)
    The display format that the label should be shown in.
    Enum: "label", "paperless", "label_and_paperless"

  - `test_label` (boolean)
    Indicate if this label is being used only for testing purposes. If true, then no charge will be added to your account.
    Example: true

  - `label_download_type` (string)
    There are two different ways to [download a label]:

|Label Download Type | Description
|--------------------|------------------------------
|url               |You will receive a URL, which you can use to download the label in a separate request. The URL will remain valid for 90 days.This is the default if label_download_type is unspecified.
|inline            |You will receive the Base64-encoded label as part of the response. No need for a second request to download the label.
    Enum: "url", "inline"

  - `is_return_label` (boolean)
    Indicates whether these are return labels.
    Example: true

  - `rma_number` (string,null)
    An optional Return Merchandise Authorization number for return labels.
    Example: "asd12323"

  - `charge_event` (string)
    The label charge event.
    Enum: "carrier_default", "on_creation", "on_carrier_acceptance"

  - `outbound_label_id` (string)
    The label_id of the original (outgoing) label that the return label is for.
    Example: "se-28529731"

  - `validate_address` (string)
    The possible validate address values
    Enum: "no_validation", "validate_only", "validate_and_clean"

  - `label_image_id` (string,null)
    The label image resource that was used to create a custom label image.
    Example: "img_DtBXupDBxREpHnwEXhTfgK"

  - `ship_to_service_point_id` (string,null)
    A unique identifier for a carrier service point where the shipment will be delivered.
    Example: "614940"

  - `ship_from_service_point_id` (string,null)
    A unique identifier for a carrier drop off point where a merchant plans to deliver packages.
    Example: "614940"

## Response 200 fields (application/json):

  - `label_id` (string)
    A string that uniquely identifies the label. This ID is generated by ShipStation when the label is created.
    Example: "se-28529731"

  - `status` (string)
    The possible statuses that a [shipping label] can be in.

|Status       |Description
|:------------|:-----------------------------------------------------
|processing |When labels are created in a [batch], it may take a few minutes for all of the labels in the batch to be created.  During this period, they will be in processing status.
|completed  |The label was successfully created
|error      |The label could not be created due to an error, such as an invalid delivery address
|voided     |The label has been [voided]
    Enum: "processing", "completed", "error", "voided"

  - `shipment_id` (string)
    The shipment that this label is for.  ShipStation  can create a shipment for you automatically when you [create a label], or you can [create your own shipment] and then [use it to print a label]
    Example: "se-28529731"

  - `external_shipment_id` (string,null)
    A unique user-defined key to identify a shipment.  This can be used to retrieve the shipment.

> Warning: The external_shipment_id is limited to 50 characters. Any additional characters will be truncated.
    Example: "externalId-1234556"

  - `external_order_id` (string,null)
    ID that the Order Source assigned
    Example: "externalOrderId-1232434"

  - `ship_date` (string)
    The date that the package was (or will be) shipped.  ShipStation will take the day of week into consideration. For example, if the carrier does not operate on Sundays, then a package that would have shipped on Sunday will ship on Monday instead.
    Example: "2018-09-23T00:00:00Z"

  - `created_at` (string)
    The date and time that the label was created in ShipStation .
    Example: "2018-09-23T15:00:00.000Z"

  - `shipment_cost` (object)
    The cost of shipping, delivery confirmation, and other carrier charges.  This amount does not include insurance costs.

  - `shipment_cost.currency` (string, required)
    Currency code
    Example: "usd"

  - `shipment_cost.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `insurance_cost` (object)
    The insurance cost for this package.  Add this to the shipment_cost field to get the total cost.

  - `insurance_cost.currency` (string, required)
    Currency code
    Example: "usd"

  - `insurance_cost.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `requested_comparison_amount` (object)
    The total shipping cost for the specified comparison_rate_type.

  - `requested_comparison_amount.currency` (string, required)
    Currency code
    Example: "usd"

  - `requested_comparison_amount.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `tracking_number` (string)
    The tracking number for the package. Tracking number formats vary across carriers.
    Example: "782758401696"

  - `is_return_label` (boolean)
    Indicates whether this is a return label.  You may also want to set the rma_number so you know what is being returned.
    Example: true

  - `rma_number` (string,null)
    An optional Return Merchandise Authorization number.  This field is useful for return labels.  You can set it to any string value.
    Example: "asd12323"

  - `is_international` (boolean)
    Indicates whether this is an international shipment.  That is, the originating country and destination country are different.
    Example: true

  - `batch_id` (string)
    If this label was created as part of a [batch], then this is the unique ID of that batch.
    Example: "se-28529731"

  - `carrier_id` (string)
    The unique ID of the [carrier account] that was used to create this label
    Example: "se-28529731"

  - `charge_event` (string)
    The label charge event.
    Enum: "carrier_default", "on_creation", "on_carrier_acceptance"

  - `service_code` (string)
    The [carrier service] used to ship the package, such as fedex_ground, usps_first_class_mail, flat_rate_envelope, etc.
    Example: "usps_first_class_mail"

  - `package_code` (string)
    The [package type], such as thick_envelope, small_flat_rate_box, large_package, etc.  The code package indicates a custom or unknown package type.
    Example: "small_flat_rate_box"

  - `voided` (boolean)
    Indicates whether the label has been [voided]
    Example: true

  - `voided_at` (string,null)
    The date and time that the label was [voided] , or null if the label has not been voided
    Example: "2018-09-23T15:00:00.000Z"

  - `void_type` (string,null)
    Indicates how the label was voided. This field is null if the label has not been voided.
    Enum: "refund_assist", "manual"

  - `refund_details` (object,null)
    Information about the Refund Assist request for this label. This field is null if the label is not eligible for Refund Assist.

  - `refund_details.refund_status` (string)
    The current status of the refund request
    Enum: "request_scheduled", "pending", "approved", "rejected", "excluded"

  - `refund_details.request_date` (string)
    The date and time when the refund request was submitted
    Example: "2018-09-23T15:00:00.000Z"

  - `refund_details.amount_paid` (object,null)
    The amount that was originally paid for the label

  - `refund_details.amount_paid.currency` (string, required)
    Currency code
    Example: "usd"

  - `refund_details.amount_paid.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `refund_details.amount_requested` (object,null)
    The amount requested to be refunded

  - `refund_details.amount_requested.currency` (string, required)
    Currency code
    Example: "usd"

  - `refund_details.amount_requested.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `refund_details.amount_approved` (object,null)
    The amount approved for refund by the carrier

  - `refund_details.amount_approved.currency` (string, required)
    Currency code
    Example: "usd"

  - `refund_details.amount_approved.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `refund_details.amount_credited` (object,null)
    The amount that has been credited back to the account

  - `refund_details.amount_credited.currency` (string, required)
    Currency code
    Example: "usd"

  - `refund_details.amount_credited.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `label_format` (string)
    The file format that you want the label to be in.  We recommend pdf format because it is supported by all carriers, whereas some carriers do not support the png or zpl formats.
    Enum: "pdf", "png", "zpl"

  - `display_scheme` (string)
    The display format that the label should be shown in.
    Enum: "label", "paperless", "label_and_paperless"

  - `label_layout` (string)
    The layout (size) that you want the label to be in.  The label_format determines which sizes are allowed.  4x6 is supported for all label formats, whereas letter (8.5" x 11") is only supported for pdf format.
    Enum: "4x6", "letter"

  - `trackable` (boolean)
    Indicates whether the shipment is trackable, in which case the tracking_status field will reflect the current status and each package will have a tracking_number.
    Example: true

  - `label_image_id` (string,null)
    The label image resource that was used to create a custom label image.
    Example: "img_DtBXupDBxREpHnwEXhTfgK"

  - `carrier_code` (string)
    The [shipping carrier] who will ship the package, such as fedex, dhl_express, stamps_com, etc.
    Example: "dhl_express"

  - `confirmation` (string)
    The type of delivery confirmation that is required for this shipment.
    Enum: "none", "delivery", "signature", "adult_signature", "direct_signature", "delivery_mailed", "verbal_confirmation", "delivery_code", "age_verification_16_plus"

  - `tracking_status` (string)
    The current status of the package, such as in_transit or delivered
    Enum: "unknown", "in_transit", "error", "delivered"

  - `label_download` (object)
    Reference to the various downloadable file formats for the generated label

  - `label_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `label_download.pdf` (string)
    The URL for the pdf generated label
    Example: "https://example.com/resource"

  - `label_download.png` (string)
    The URL for the png generated label
    Example: "https://example.com/resource"

  - `label_download.zpl` (string)
    The URL for the zpl generated label
    Example: "https://example.com/resource"

  - `form_download` (object,null)
    The link to download the customs form (a.k.a. commercial invoice) for this shipment, if any.  Forms are in PDF format. This field is null if the shipment does not require a customs form, or if the carrier does not support it.

  - `form_download.href` (string, required)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `form_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `qr_code_download` (object,null)
    The QR code download for the package

  - `qr_code_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `qr_code_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `paperless_download` (object,null)
    The paperless details which may contain elements like href, instructions and handoff_code.

  - `paperless_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `paperless_download.instructions` (string,null)
    The instructions for the paperless download.
    Example: "any instructions"

  - `paperless_download.handoff_code` (string,null)
    The handoff code for the paperless download.
    Example: "122334"

  - `insurance_claim` (object,null)
    The link to submit an insurance claim for the shipment.  This field is null if the shipment is not insured or if the insurance provider does not support online claim submission.

  - `insurance_claim.href` (string, required)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `insurance_claim.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `packages` (array)
    The label's package(s).

> Note: Some carriers only allow one package per label.  If you attempt to create a multi-package label for a carrier that doesn't allow it, an error will be returned.

  - `packages.package_id` (integer)
    The shipment package id
    Example: 1234545

  - `packages.package_code` (string)
    The [package type], such as thick_envelope, small_flat_rate_box, large_package, etc.  The code package indicates a custom or unknown package type.
    Example: "small_flat_rate_box"

  - `packages.weight` (object, required)
    The package weight

  - `packages.weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `packages.weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `packages.dimensions` (object)
    The package dimensions

  - `packages.dimensions.unit` (string, required)
    Dimension unit
    Enum: "inch", "centimeter"

  - `packages.dimensions.length` (number, required)
    The length of the package, in the specified unit
    Example: 2

  - `packages.dimensions.width` (number, required)
    The width of the package, in the specified unit
    Example: 2

  - `packages.dimensions.height` (number, required)
    The height of the package, in the specified unit
    Example: 1

  - `packages.insured_value` (object)
    The insured value of the package.  Requires the insurance_provider field of the shipment to be set.

  - `packages.insured_value.currency` (string, required)
    Currency code
    Example: "usd"

  - `packages.insured_value.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `packages.tracking_number` (string)
    The tracking number for the package.  The format depends on the carrier.
    Example: "1Z932R800392060079"

  - `packages.label_download` (object)
    The label download for the package

  - `packages.label_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `packages.label_download.pdf` (string)
    The URL for the pdf generated label
    Example: "https://example.com/resource"

  - `packages.label_download.png` (string)
    The URL for the png generated label
    Example: "https://example.com/resource"

  - `packages.label_download.zpl` (string)
    The URL for the zpl generated label
    Example: "https://example.com/resource"

  - `packages.form_download` (object)
    The form download for any customs that are needed

  - `packages.form_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `packages.form_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `packages.qr_code_download` (object)
    The QR code download for the package

  - `packages.qr_code_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `packages.qr_code_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `packages.paperless_download` (object)
    The paperless details which may contain elements like href, instructions and handoff_code.

  - `packages.paperless_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `packages.paperless_download.instructions` (string,null)
    The instructions for the paperless download.
    Example: "any instructions"

  - `packages.paperless_download.handoff_code` (string,null)
    The handoff code for the paperless download.
    Example: "122334"

  - `packages.label_messages` (object)
    Custom messages to print on the shipping label for the package.  These are typically used to print invoice numbers, product numbers, or other internal reference numbers.  Not all carriers support label messages. The number of lines and the maximum length of each line also varies by carrier.

|Carrier            |Max lines |Max line length
|-------------------|----------|--------------------
|USPS (Stamps.com)  |3         |60
|FedEx              |3         |35 for the first line. 30 for additional lines.
|UPS                |2         |35
|OnTrac             |2         |25

  - `packages.label_messages.reference1` (string,null, required)
    The first line of the custom label message.  Some carriers may prefix this line with something like "REF", "Reference", "Trx Ref No.", etc.
    Example: "Reference"

  - `packages.label_messages.reference2` (string,null, required)
    The second line of the custom label message.  Some carriers may prefix this line with something like "INV", "Reference 2", "Trx Ref No.", etc.
    Example: "Reference 2"

  - `packages.label_messages.reference3` (string,null, required)
    The third line of the custom label message.  Some carriers may prefix this line with something like "PO", "Reference 3", etc.
    Example: "Reference 3"

  - `packages.external_package_id` (string)
    An external package id.
    Example: "se-1234567"

  - `packages.content_description` (string,null)
    A short description of the package content. Required for shipments moving to, from, and through Mexico.
    Example: "Hand knitted wool socks"

  - `packages.sequence` (integer)
    Package sequence
    Example: 34

  - `packages.has_label_documents` (boolean)
    Whether the package has label documents available for download
    Example: true

  - `packages.has_form_documents` (boolean)
    Whether the package has form documents available for download
    Example: true

  - `packages.has_qr_code_documents` (boolean)
    Whether the package has QR code documents available for download
    Example: true

  - `packages.has_paperless_label_documents` (boolean)
    Whether the package has paperless documents available for download
    Example: true

  - `packages.alternative_identifiers` (array,null)
    Alternative identifiers associated with this package.

  - `packages.alternative_identifiers.type` (string)
    The type of alternative_identifier that corresponds to the value.
    Example: "last_mile_tracking_number"

  - `packages.alternative_identifiers.value` (string)
    The value of the alternative_identifier.
    Example: "12345678912345678912"

  - `alternative_identifiers` (array,null)
    Additional information some carriers may provide by which to identify a given label in their system.

  - `rate_details` (array)
    A breakdown of individual charges that make up this label, such as base shipping cost and additional fees. For DDP shipments it also includes duties, taxes, and import fees (prepaid on Wallet carriers, estimated on BYOA carriers).

  - `rate_details.rate_detail_type` (string)
    The category of charge. Common values include shipping and additional_fees. DDP shipments (customs.terms_of_trade_code: "ddp") also return prepaid_duties, prepaid_taxes and prepaid_import_fees on Wallet carriers, or estimated_duties, estimated_taxes and estimated_import_fees on BYOA (Bring Your Own Account) carriers.
    Example: "shipping"

  - `rate_details.carrier_description` (string)
    The carrier-provided description of the charge.
    Example: "Shipping"

  - `rate_details.carrier_billing_code` (string,null)
    The carrier billing code, when provided by the carrier.
    Example: "BaseServiceCharge"

  - `rate_details.carrier_memo` (string,null)
    An optional carrier-supplied note for the charge.

  - `rate_details.amount` (object)
    The amount of this individual charge.

  - `rate_details.amount.currency` (string, required)
    Currency code
    Example: "usd"

  - `rate_details.amount.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `rate_details.billing_source` (string)
    The source that produced the charge. Common values are carrier for carrier-billed charges and dutiestax for duties and taxes on DDP shipments (prepaid on Wallet carriers, estimated on BYOA carriers).

> Note: The casing of this value differs by endpoint. Label responses return lowercase values (e.g. carrier, dutiestax). Rate responses return PascalCase values (e.g. Carrier, DutiesTax). This reflects the actual API behavior.
    Example: "carrier"

  - `tracking_url` (string,null)
    The URL to track the package. This URL is provided by the carrier and is unique to the tracking number.
    Example: "https://www.fedex.com/fedextrack/?action=track&trackingnumber=1234"

  - `ship_to` (object)
    The recipient's mailing address

  - `ship_to.name` (string, required)
    The name of a contact person at this address.  This field may be set instead of - or in addition to - the company_name field.
    Example: "John Doe"

  - `ship_to.phone` (string, required)
    The phone number of a contact person at this address.  The format of this phone number varies depending on the country.
    Example: "+1 204-253-9411 ext. 123"

  - `ship_to.email` (string,null)
    Email for the address owner.
    Example: "example@example.com"

  - `ship_to.company_name` (string,null)
    If this is a business address, then the company name should be specified here.
    Example: "The Home Depot"

  - `ship_to.address_line1` (string, required)
    The first line of the street address.  For some addresses, this may be the only line.  Other addresses may require 2 or 3 lines.
    Example: "1999 Bishop Grandin Blvd."

  - `ship_to.address_line2` (string,null)
    The second line of the street address.  For some addresses, this line may not be needed.
    Example: "Unit 408"

  - `ship_to.address_line3` (string,null)
    The third line of the street address.  For some addresses, this line may not be needed.
    Example: "Building #7"

  - `ship_to.city_locality` (string, required)
    The name of the city or locality
    Example: "Winnipeg"

  - `ship_to.state_province` (string, required)
    The state or province.  For some countries (including the U.S.) only abbreviations are allowed.  Other countries allow the full name or abbreviation.
    Example: "Manitoba"

  - `ship_to.postal_code` (string, required)
    postal code
    Example: "78756-3717"

  - `ship_to.country_code` (string, required)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1)
    Example: "CA"

  - `ship_to.address_residential_indicator` (string, required)
    Indicates whether this is a residential address.
    Enum: "unknown", "yes", "no"

  - `ship_to.instructions` (string,null)
    Additional text about how to handle the shipment at this address.
    Example: "any instruction"

  - `ship_to.geolocation` (array)

  - `ship_to.geolocation.type` (string)
    Enum of available type of geolocation items:
  - 'what3words' functionality allows to specify a location by providing 3 words that have been assigned to the specific location. See [link](https://what3words.com/business) for more details.
    Enum: "what3words"

  - `ship_to.geolocation.value` (string)
    value of the geolocation item
    Example: "cats.with.thumbs"

  - `total_cost` (object)
    The combined cost of all labels in this mailing request.

  - `total_cost.currency` (string, required)
    Currency code
    Example: "usd"

  - `total_cost.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels` (array)
    The individual labels created for each shipment in the request.

  - `associated_labels.label_id` (string, required)
    A string that uniquely identifies the label. This ID is generated by ShipStation when the label is created.
    Example: "se-28529731"

  - `associated_labels.status` (string, required)
    The possible statuses that a [shipping label] can be in.

|Status       |Description
|:------------|:-----------------------------------------------------
|processing |When labels are created in a [batch], it may take a few minutes for all of the labels in the batch to be created.  During this period, they will be in processing status.
|completed  |The label was successfully created
|error      |The label could not be created due to an error, such as an invalid delivery address
|voided     |The label has been [voided]
    Enum: "processing", "completed", "error", "voided"

  - `associated_labels.shipment_id` (string, required)
    The shipment that this label is for.  ShipStation  can create a shipment for you automatically when you [create a label], or you can [create your own shipment] and then [use it to print a label]
    Example: "se-28529731"

  - `associated_labels.external_shipment_id` (string,null)
    A unique user-defined key to identify a shipment.  This can be used to retrieve the shipment.

> Warning: The external_shipment_id is limited to 50 characters. Any additional characters will be truncated.
    Example: "externalId-1234556"

  - `associated_labels.external_order_id` (string,null)
    ID that the Order Source assigned
    Example: "externalOrderId-1232434"

  - `associated_labels.ship_date` (string, required)
    The date that the package was (or will be) shipped.  ShipStation will take the day of week into consideration. For example, if the carrier does not operate on Sundays, then a package that would have shipped on Sunday will ship on Monday instead.
    Example: "2018-09-23T00:00:00Z"

  - `associated_labels.created_at` (string, required)
    The date and time that the label was created in ShipStation .
    Example: "2018-09-23T15:00:00.000Z"

  - `associated_labels.shipment_cost` (object, required)
    The cost of shipping, delivery confirmation, and other carrier charges.  This amount does not include insurance costs.

  - `associated_labels.shipment_cost.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.shipment_cost.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.insurance_cost` (object, required)
    The insurance cost for this package.  Add this to the shipment_cost field to get the total cost.

  - `associated_labels.insurance_cost.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.insurance_cost.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.requested_comparison_amount` (object)
    The total shipping cost for the specified comparison_rate_type.

  - `associated_labels.requested_comparison_amount.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.requested_comparison_amount.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.tracking_number` (string, required)
    The tracking number for the package. Tracking number formats vary across carriers.
    Example: "782758401696"

  - `associated_labels.is_return_label` (boolean, required)
    Indicates whether this is a return label.  You may also want to set the rma_number so you know what is being returned.
    Example: true

  - `associated_labels.rma_number` (string,null, required)
    An optional Return Merchandise Authorization number.  This field is useful for return labels.  You can set it to any string value.
    Example: "asd12323"

  - `associated_labels.is_international` (boolean, required)
    Indicates whether this is an international shipment.  That is, the originating country and destination country are different.
    Example: true

  - `associated_labels.batch_id` (string, required)
    If this label was created as part of a [batch], then this is the unique ID of that batch.
    Example: "se-28529731"

  - `associated_labels.carrier_id` (string, required)
    The unique ID of the [carrier account] that was used to create this label
    Example: "se-28529731"

  - `associated_labels.charge_event` (string, required)
    The label charge event.
    Enum: "carrier_default", "on_creation", "on_carrier_acceptance"

  - `associated_labels.service_code` (string, required)
    The [carrier service] used to ship the package, such as fedex_ground, usps_first_class_mail, flat_rate_envelope, etc.
    Example: "usps_first_class_mail"

  - `associated_labels.package_code` (string, required)
    The [package type], such as thick_envelope, small_flat_rate_box, large_package, etc.  The code package indicates a custom or unknown package type.
    Example: "small_flat_rate_box"

  - `associated_labels.voided` (boolean, required)
    Indicates whether the label has been [voided]
    Example: true

  - `associated_labels.voided_at` (string,null, required)
    The date and time that the label was [voided] , or null if the label has not been voided
    Example: "2018-09-23T15:00:00.000Z"

  - `associated_labels.void_type` (string,null)
    Indicates how the label was voided. This field is null if the label has not been voided.
    Enum: "refund_assist", "manual"

  - `associated_labels.refund_details` (object,null)
    Information about the Refund Assist request for this label. This field is null if the label is not eligible for Refund Assist.

  - `associated_labels.refund_details.refund_status` (string)
    The current status of the refund request
    Enum: "request_scheduled", "pending", "approved", "rejected", "excluded"

  - `associated_labels.refund_details.request_date` (string)
    The date and time when the refund request was submitted
    Example: "2018-09-23T15:00:00.000Z"

  - `associated_labels.refund_details.amount_paid` (object,null)
    The amount that was originally paid for the label

  - `associated_labels.refund_details.amount_paid.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.refund_details.amount_paid.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.refund_details.amount_requested` (object,null)
    The amount requested to be refunded

  - `associated_labels.refund_details.amount_requested.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.refund_details.amount_requested.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.refund_details.amount_approved` (object,null)
    The amount approved for refund by the carrier

  - `associated_labels.refund_details.amount_approved.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.refund_details.amount_approved.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.refund_details.amount_credited` (object,null)
    The amount that has been credited back to the account

  - `associated_labels.refund_details.amount_credited.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.refund_details.amount_credited.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.label_format` (string, required)
    The file format that you want the label to be in.  We recommend pdf format because it is supported by all carriers, whereas some carriers do not support the png or zpl formats.
    Enum: "pdf", "png", "zpl"

  - `associated_labels.display_scheme` (string, required)
    The display format that the label should be shown in.
    Enum: "label", "paperless", "label_and_paperless"

  - `associated_labels.label_layout` (string, required)
    The layout (size) that you want the label to be in.  The label_format determines which sizes are allowed.  4x6 is supported for all label formats, whereas letter (8.5" x 11") is only supported for pdf format.
    Enum: "4x6", "letter"

  - `associated_labels.trackable` (boolean, required)
    Indicates whether the shipment is trackable, in which case the tracking_status field will reflect the current status and each package will have a tracking_number.
    Example: true

  - `associated_labels.label_image_id` (string,null, required)
    The label image resource that was used to create a custom label image.
    Example: "img_DtBXupDBxREpHnwEXhTfgK"

  - `associated_labels.carrier_code` (string, required)
    The [shipping carrier] who will ship the package, such as fedex, dhl_express, stamps_com, etc.
    Example: "dhl_express"

  - `associated_labels.confirmation` (string)
    The type of delivery confirmation that is required for this shipment.
    Enum: "none", "delivery", "signature", "adult_signature", "direct_signature", "delivery_mailed", "verbal_confirmation", "delivery_code", "age_verification_16_plus"

  - `associated_labels.tracking_status` (string, required)
    The current status of the package, such as in_transit or delivered
    Enum: "unknown", "in_transit", "error", "delivered"

  - `associated_labels.label_download` (object, required)
    Reference to the various downloadable file formats for the generated label

  - `associated_labels.label_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.label_download.pdf` (string)
    The URL for the pdf generated label
    Example: "https://example.com/resource"

  - `associated_labels.label_download.png` (string)
    The URL for the png generated label
    Example: "https://example.com/resource"

  - `associated_labels.label_download.zpl` (string)
    The URL for the zpl generated label
    Example: "https://example.com/resource"

  - `associated_labels.form_download` (object,null, required)
    The link to download the customs form (a.k.a. commercial invoice) for this shipment, if any.  Forms are in PDF format. This field is null if the shipment does not require a customs form, or if the carrier does not support it.

  - `associated_labels.form_download.href` (string, required)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.form_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `associated_labels.qr_code_download` (object,null)
    The QR code download for the package

  - `associated_labels.qr_code_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.qr_code_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `associated_labels.paperless_download` (object,null, required)
    The paperless details which may contain elements like href, instructions and handoff_code.

  - `associated_labels.paperless_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.paperless_download.instructions` (string,null)
    The instructions for the paperless download.
    Example: "any instructions"

  - `associated_labels.paperless_download.handoff_code` (string,null)
    The handoff code for the paperless download.
    Example: "122334"

  - `associated_labels.insurance_claim` (object,null, required)
    The link to submit an insurance claim for the shipment.  This field is null if the shipment is not insured or if the insurance provider does not support online claim submission.

  - `associated_labels.insurance_claim.href` (string, required)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.insurance_claim.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `associated_labels.packages` (array, required)
    The label's package(s).

> Note: Some carriers only allow one package per label.  If you attempt to create a multi-package label for a carrier that doesn't allow it, an error will be returned.

  - `associated_labels.packages.package_id` (integer)
    The shipment package id
    Example: 1234545

  - `associated_labels.packages.package_code` (string)
    The [package type], such as thick_envelope, small_flat_rate_box, large_package, etc.  The code package indicates a custom or unknown package type.
    Example: "small_flat_rate_box"

  - `associated_labels.packages.weight` (object, required)
    The package weight

  - `associated_labels.packages.weight.value` (number, required)
    The weight, in the specified unit
    Example: 23

  - `associated_labels.packages.weight.unit` (string, required)
    Weight unit
    Enum: "pound", "ounce", "gram", "kilogram"

  - `associated_labels.packages.dimensions` (object)
    The package dimensions

  - `associated_labels.packages.dimensions.unit` (string, required)
    Dimension unit
    Enum: "inch", "centimeter"

  - `associated_labels.packages.dimensions.length` (number, required)
    The length of the package, in the specified unit
    Example: 2

  - `associated_labels.packages.dimensions.width` (number, required)
    The width of the package, in the specified unit
    Example: 2

  - `associated_labels.packages.dimensions.height` (number, required)
    The height of the package, in the specified unit
    Example: 1

  - `associated_labels.packages.insured_value` (object)
    The insured value of the package.  Requires the insurance_provider field of the shipment to be set.

  - `associated_labels.packages.insured_value.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.packages.insured_value.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.packages.tracking_number` (string)
    The tracking number for the package.  The format depends on the carrier.
    Example: "1Z932R800392060079"

  - `associated_labels.packages.label_download` (object)
    The label download for the package

  - `associated_labels.packages.label_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.packages.label_download.pdf` (string)
    The URL for the pdf generated label
    Example: "https://example.com/resource"

  - `associated_labels.packages.label_download.png` (string)
    The URL for the png generated label
    Example: "https://example.com/resource"

  - `associated_labels.packages.label_download.zpl` (string)
    The URL for the zpl generated label
    Example: "https://example.com/resource"

  - `associated_labels.packages.form_download` (object)
    The form download for any customs that are needed

  - `associated_labels.packages.form_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.packages.form_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `associated_labels.packages.qr_code_download` (object)
    The QR code download for the package

  - `associated_labels.packages.qr_code_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.packages.qr_code_download.type` (string)
    The type of resource, or the type of relationship to the parent resource
    Example: "child"

  - `associated_labels.packages.paperless_download` (object)
    The paperless details which may contain elements like href, instructions and handoff_code.

  - `associated_labels.packages.paperless_download.href` (string)
    The URL of the linked resource, if any
    Example: "https://example.com/resource"

  - `associated_labels.packages.paperless_download.instructions` (string,null)
    The instructions for the paperless download.
    Example: "any instructions"

  - `associated_labels.packages.paperless_download.handoff_code` (string,null)
    The handoff code for the paperless download.
    Example: "122334"

  - `associated_labels.packages.label_messages` (object)
    Custom messages to print on the shipping label for the package.  These are typically used to print invoice numbers, product numbers, or other internal reference numbers.  Not all carriers support label messages. The number of lines and the maximum length of each line also varies by carrier.

|Carrier            |Max lines |Max line length
|-------------------|----------|--------------------
|USPS (Stamps.com)  |3         |60
|FedEx              |3         |35 for the first line. 30 for additional lines.
|UPS                |2         |35
|OnTrac             |2         |25

  - `associated_labels.packages.label_messages.reference1` (string,null, required)
    The first line of the custom label message.  Some carriers may prefix this line with something like "REF", "Reference", "Trx Ref No.", etc.
    Example: "Reference"

  - `associated_labels.packages.label_messages.reference2` (string,null, required)
    The second line of the custom label message.  Some carriers may prefix this line with something like "INV", "Reference 2", "Trx Ref No.", etc.
    Example: "Reference 2"

  - `associated_labels.packages.label_messages.reference3` (string,null, required)
    The third line of the custom label message.  Some carriers may prefix this line with something like "PO", "Reference 3", etc.
    Example: "Reference 3"

  - `associated_labels.packages.external_package_id` (string)
    An external package id.
    Example: "se-1234567"

  - `associated_labels.packages.content_description` (string,null)
    A short description of the package content. Required for shipments moving to, from, and through Mexico.
    Example: "Hand knitted wool socks"

  - `associated_labels.packages.sequence` (integer)
    Package sequence
    Example: 34

  - `associated_labels.packages.has_label_documents` (boolean)
    Whether the package has label documents available for download
    Example: true

  - `associated_labels.packages.has_form_documents` (boolean)
    Whether the package has form documents available for download
    Example: true

  - `associated_labels.packages.has_qr_code_documents` (boolean)
    Whether the package has QR code documents available for download
    Example: true

  - `associated_labels.packages.has_paperless_label_documents` (boolean)
    Whether the package has paperless documents available for download
    Example: true

  - `associated_labels.packages.alternative_identifiers` (array,null)
    Alternative identifiers associated with this package.

  - `associated_labels.alternative_identifiers` (array,null)
    Additional information some carriers may provide by which to identify a given label in their system.

  - `associated_labels.rate_details` (array, required)
    A breakdown of individual charges that make up this label, such as base shipping cost and additional fees. For DDP shipments it also includes duties, taxes, and import fees (prepaid on Wallet carriers, estimated on BYOA carriers).

  - `associated_labels.rate_details.rate_detail_type` (string)
    The category of charge. Common values include shipping and additional_fees. DDP shipments (customs.terms_of_trade_code: "ddp") also return prepaid_duties, prepaid_taxes and prepaid_import_fees on Wallet carriers, or estimated_duties, estimated_taxes and estimated_import_fees on BYOA (Bring Your Own Account) carriers.
    Example: "shipping"

  - `associated_labels.rate_details.carrier_description` (string)
    The carrier-provided description of the charge.
    Example: "Shipping"

  - `associated_labels.rate_details.carrier_billing_code` (string,null)
    The carrier billing code, when provided by the carrier.
    Example: "BaseServiceCharge"

  - `associated_labels.rate_details.carrier_memo` (string,null)
    An optional carrier-supplied note for the charge.

  - `associated_labels.rate_details.amount` (object)
    The amount of this individual charge.

  - `associated_labels.rate_details.amount.currency` (string, required)
    Currency code
    Example: "usd"

  - `associated_labels.rate_details.amount.amount` (number, required)
    The monetary amount, in the specified currency.
    Example: 12

  - `associated_labels.rate_details.billing_source` (string)
    The source that produced the charge. Common values are carrier for carrier-billed charges and dutiestax for duties and taxes on DDP shipments (prepaid on Wallet carriers, estimated on BYOA carriers).

> Note: The casing of this value differs by endpoint. Label responses return lowercase values (e.g. carrier, dutiestax). Rate responses return PascalCase values (e.g. Carrier, DutiesTax). This reflects the actual API behavior.
    Example: "carrier"

  - `associated_labels.tracking_url` (string,null)
    The URL to track the package. This URL is provided by the carrier and is unique to the tracking number.
    Example: "https://www.fedex.com/fedextrack/?action=track&trackingnumber=1234"

  - `associated_labels.ship_to` (object)
    The recipient's mailing address

  - `associated_labels.ship_to.name` (string, required)
    The name of a contact person at this address.  This field may be set instead of - or in addition to - the company_name field.
    Example: "John Doe"

  - `associated_labels.ship_to.phone` (string, required)
    The phone number of a contact person at this address.  The format of this phone number varies depending on the country.
    Example: "+1 204-253-9411 ext. 123"

  - `associated_labels.ship_to.email` (string,null)
    Email for the address owner.
    Example: "example@example.com"

  - `associated_labels.ship_to.company_name` (string,null)
    If this is a business address, then the company name should be specified here.
    Example: "The Home Depot"

  - `associated_labels.ship_to.address_line1` (string, required)
    The first line of the street address.  For some addresses, this may be the only line.  Other addresses may require 2 or 3 lines.
    Example: "1999 Bishop Grandin Blvd."

  - `associated_labels.ship_to.address_line2` (string,null)
    The second line of the street address.  For some addresses, this line may not be needed.
    Example: "Unit 408"

  - `associated_labels.ship_to.address_line3` (string,null)
    The third line of the street address.  For some addresses, this line may not be needed.
    Example: "Building #7"

  - `associated_labels.ship_to.city_locality` (string, required)
    The name of the city or locality
    Example: "Winnipeg"

  - `associated_labels.ship_to.state_province` (string, required)
    The state or province.  For some countries (including the U.S.) only abbreviations are allowed.  Other countries allow the full name or abbreviation.
    Example: "Manitoba"

  - `associated_labels.ship_to.postal_code` (string, required)
    postal code
    Example: "78756-3717"

  - `associated_labels.ship_to.country_code` (string, required)
    The two-letter [ISO 3166-1 country code](https://en.wikipedia.org/wiki/ISO_3166-1)
    Example: "CA"

  - `associated_labels.ship_to.address_residential_indicator` (string, required)
    Indicates whether this is a residential address.
    Enum: "unknown", "yes", "no"

  - `associated_labels.ship_to.instructions` (string,null)
    Additional text about how to handle the shipment at this address.
    Example: "any instruction"

  - `associated_labels.ship_to.geolocation` (array)

  - `associated_labels.ship_to.geolocation.type` (string)
    Enum of available type of geolocation items:
  - 'what3words' functionality allows to specify a location by providing 3 words that have been assigned to the specific location. See [link](https://what3words.com/business) for more details.
    Enum: "what3words"

  - `associated_labels.ship_to.geolocation.value` (string)
    value of the geolocation item
    Example: "cats.with.thumbs"

## Response 400 fields (application/json):

  - `request_id` (string, required)
    A UUID that uniquely identifies the request id.
This can be given to the support team to help debug non-trivial issues that may occur
    Example: "aa3d8e8e-462b-4476-9618-72db7f7b7009"

  - `errors` (array, required)
    The errors associated with the failed API call

  - `errors.error_source` (string, required)
    The source of the error, as indicated by the name this informs us if the API call failed because of the
carrier, the order source, the ShipStation API itself, or the underlying ShipEngine platform.
    Enum: "carrier", "order_source", "ShipStation", "shipengine"

  - `errors.error_type` (string, required)
    The type of error
    Enum: "account_status", "business_rules", "validation", "security", "system", "integrations"

  - `errors.error_code` (string, required)
    The error code specified for the failed API Call
    Enum: "auto_fund_not_supported", "batch_cannot_be_modified", "carrier_conflict", "carrier_disconnected", "carrier_not_connected", "carrier_not_supported", "confirmation_not_supported", "default_warehouse_cannot_be_deleted", "field_conflict", "field_value_required", "forbidden", "identifier_conflict", "identifiers_must_match", "insufficient_funds", "invalid_address", "invalid_billing_plan", "invalid_field_value", "invalid_identifier", "invalid_status", "invalid_string_length", "label_images_not_supported", "meter_failure", "order_source_not_active", "rate_limit_exceeded", "refresh_not_supported", "request_body_required", "return_label_not_supported", "settings_not_supported", "subscription_inactive", "terms_not_accepted", "tracking_not_supported", "trial_expired", "unauthorized", "unknown", "unspecified", "verification_failure", "warehouse_conflict", "webhook_event_type_conflict", "customs_items_required", "incompatible_paired_labels", "invalid_charge_event", "invalid_object", "no_rates_returned"

  - `errors.message` (string, required)
    An error message associated with the failed API call
    Example: "Body of request cannot be null."

  - `errors.field_name` (string)
    The name of the field that caused the error (only present for validation errors)
    Example: "inventory_warehouse_id"

  - `errors.field_value` (string)
    The invalid value that was provided for the field (only present for validation errors)
    Example: "invalid-id"


